﻿@inject HttpClient HttpClient

<EditForm Model="@Prefecture" OnValidSubmit="Submit">
    <DataAnnotationsValidator />
    <MudDialog>
        <DialogContent>
            <MudTextField T="int" Label="都道府県ID" @bind-Value="Prefecture.PrefectureId" For="@(() => Prefecture.PrefectureId)" ReadOnly="true" />
            <MudSelect T="int" Label="地方" For="@(() => Prefecture.RegionId)" @bind-Value="Prefecture.RegionId" Variant="Variant.Filled" ReadOnly="@IsReadOnly">
                @if (_regions != null)
                {
                    @foreach (var region in _regions)
                    {
                        <MudSelectItem Value="@(region.RegionId)">@region.RegionName</MudSelectItem>
                    }
                }
            </MudSelect>
            <MudTextField T="string" Label="都道府県名" @bind-Value="Prefecture.PrefectureName" For="@(() => Prefecture.PrefectureName)" ReadOnly="@IsReadOnly" />
        </DialogContent>
        <DialogActions>
            <MudButton OnClick="Cancel">キャンセル</MudButton>
            @if (!IsReadOnly)
            {
                <MudButton ButtonType="ButtonType.Submit" Variant="Variant.Filled" Color="Color.Primary" Class="ml-auto">保存</MudButton>
            }
        </DialogActions>
    </MudDialog>
</EditForm>

@code{
    [CascadingParameter]
    MudDialogInstance MudDialog { get; set; }

    [Parameter]
    public PrefectureEntity Prefecture { get; set; } = new();

    [Parameter]
    public bool IsReadOnly { get; set; } = false;

    private List<RegionEntity> _regions = new();

    protected async override void OnInitialized()
    {
        _regions = await HttpClient.GetFromJsonAsync<List<RegionEntity>>("api/Regions");
    }

    private void Cancel()
    {
        MudDialog.Cancel();
    }
    private void Submit()
    {
        MudDialog.Close(DialogResult.Ok<PrefectureEntity>(Prefecture));
    }
}